/*
Serial fifo control - Copyright (C) KI6ZUM 2015
Copyright (C) 2015 by Jonathan Naylor G4KLX

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
Boston, MA  02110-1301, USA.
*/

#if !defined(SERIALRB_H)
#define  SERIALRB_H

#include <Arduino.h>

const uint16_t SERIAL_RINGBUFFER_SIZE = 255U;

class CSerialRB {
public:
  CSerialRB();
  
  uint16_t getSpace() const;
  
  uint16_t getData() const;

  void reset();

  void put(uint8_t c);

  uint8_t peek() const;

  uint8_t get();

private:
  uint8_t  m_buffer[SERIAL_RINGBUFFER_SIZE];
  uint16_t m_head;
  uint16_t m_tail;
};

#endif

